Require Import DeBruijn.
Require Import TargetSyntax.

(* THIS FILE IS AUTOMATICALLY GENERATED BY FORK. DO NOT EDIT! *)

Definition box_pair := TAbs (TPair (TLetPair (TVar 0) (TVar 1)) (TLetPair (TVar 0) (TVar 0))).

Lemma closed_box_pair:
  closed_tterm box_pair.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_box_pair.

Lemma lift_box_pair:
  forall k,
  lift_tterm k box_pair = box_pair.
Proof.
  auto.
Qed.

Hint Rewrite lift_box_pair : lift.

Lemma subst_box_pair:
  forall u k,
  subst_tterm u k box_pair = box_pair.
Proof.
  auto.
Qed.

Hint Rewrite subst_box_pair : subst.

Definition array_write := TAbs (TAbs (TLetPair (TVar 0) (TApp (TVar 0) (TVar 3)))).

Lemma closed_array_write:
  closed_tterm array_write.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_array_write.

Lemma lift_array_write:
  forall k,
  lift_tterm k array_write = array_write.
Proof.
  auto.
Qed.

Hint Rewrite lift_array_write : lift.

Lemma subst_array_write:
  forall u k,
  subst_tterm u k array_write = array_write.
Proof.
  auto.
Qed.

Hint Rewrite subst_array_write : subst.

Definition write := 
  TAbs (
    TLetPair (TApp (box_pair) (TVar 0)) (
      TAbs (
        TPair (TUnit) (
          TApp (TApp (TApp (array_write) (TVar 0)) (TVar 2)) (TVar 1)
        )
      )
    )
  )
.

Lemma closed_write:
  closed_tterm write.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_write.

Lemma lift_write:
  forall k,
  lift_tterm k write = write.
Proof.
  auto.
Qed.

Hint Rewrite lift_write : lift.

Lemma subst_write:
  forall u k,
  subst_tterm u k write = write.
Proof.
  auto.
Qed.

Hint Rewrite subst_write : subst.

Definition univ_box := TAbs (TVar 0).

Lemma closed_univ_box:
  closed_tterm univ_box.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_univ_box.

Lemma lift_univ_box:
  forall k,
  lift_tterm k univ_box = univ_box.
Proof.
  auto.
Qed.

Hint Rewrite lift_univ_box : lift.

Lemma subst_univ_box:
  forall u k,
  subst_tterm u k univ_box = univ_box.
Proof.
  auto.
Qed.

Hint Rewrite subst_univ_box : subst.

Definition __successor_get := TAbs (TAbs (TLetPair (TApp (TVar 1) (TVar 0)) (TVar 0))).

Lemma closed___successor_get:
  closed_tterm __successor_get.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed___successor_get.

Lemma lift___successor_get:
  forall k,
  lift_tterm k __successor_get = __successor_get.
Proof.
  auto.
Qed.

Hint Rewrite lift___successor_get : lift.

Lemma subst___successor_get:
  forall u k,
  subst_tterm u k __successor_get = __successor_get.
Proof.
  auto.
Qed.

Hint Rewrite subst___successor_get : subst.

Definition __successor_set := 
  TAbs (
    TAbs (
      TAbs (
        TAbs (
          TLetPair (TApp (TVar 3) (TVar 1)) (
            TApp (TApp (TVar 4) (TVar 3)) (TPair (TVar 1) (TVar 2))
          )
        )
      )
    )
  )
.

Lemma closed___successor_set:
  closed_tterm __successor_set.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed___successor_set.

Lemma lift___successor_set:
  forall k,
  lift_tterm k __successor_set = __successor_set.
Proof.
  auto.
Qed.

Hint Rewrite lift___successor_set : lift.

Lemma subst___successor_set:
  forall u k,
  subst_tterm u k __successor_set = __successor_set.
Proof.
  auto.
Qed.

Hint Rewrite subst___successor_set : subst.

Definition __successor := 
  TAbs (
    TLetPair (TVar 0) (
      TPair (TApp (__successor_get) (TVar 1)) (
        TApp (TApp (__successor_set) (TVar 1)) (TVar 0)
      )
    )
  )
.

Lemma closed___successor:
  closed_tterm __successor.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed___successor.

Lemma lift___successor:
  forall k,
  lift_tterm k __successor = __successor.
Proof.
  auto.
Qed.

Hint Rewrite lift___successor : lift.

Lemma subst___successor:
  forall u k,
  subst_tterm u k __successor = __successor.
Proof.
  auto.
Qed.

Hint Rewrite subst___successor : subst.

Definition array_extend := 
  TAbs (
    TAbs (
      TLetPair (TVar 1) (
        TLetPair (TVar 0) (
          TPair (TApp (TApp (TVar 0) (TVar 3)) (TPair (TVar 4) (TUnit))) (
            TApp (__successor) (TVar 2)
          )
        )
      )
    )
  )
.

Lemma closed_array_extend:
  closed_tterm array_extend.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_array_extend.

Lemma lift_array_extend:
  forall k,
  lift_tterm k array_extend = array_extend.
Proof.
  auto.
Qed.

Hint Rewrite lift_array_extend : lift.

Lemma subst_array_extend:
  forall u k,
  subst_tterm u k array_extend = array_extend.
Proof.
  auto.
Qed.

Hint Rewrite subst_array_extend : subst.

Definition store_extend := TAbs (TAbs (TApp (TApp (array_extend) (TVar 1)) (TVar 0))).

Lemma closed_store_extend:
  closed_tterm store_extend.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_store_extend.

Lemma lift_store_extend:
  forall k,
  lift_tterm k store_extend = store_extend.
Proof.
  auto.
Qed.

Hint Rewrite lift_store_extend : lift.

Lemma subst_store_extend:
  forall u k,
  subst_tterm u k store_extend = store_extend.
Proof.
  auto.
Qed.

Hint Rewrite subst_store_extend : subst.

Definition __array_read := 
  TAbs (
    TAbs (
      TLetPair (TVar 1) (
        TLetPair (TVar 2) (TLetPair (TApp (TVar 1) (TVar 3)) (TVar 1))
      )
    )
  )
.

Lemma closed___array_read:
  closed_tterm __array_read.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed___array_read.

Lemma lift___array_read:
  forall k,
  lift_tterm k __array_read = __array_read.
Proof.
  auto.
Qed.

Hint Rewrite lift___array_read : lift.

Lemma subst___array_read:
  forall u k,
  subst_tterm u k __array_read = __array_read.
Proof.
  auto.
Qed.

Hint Rewrite subst___array_read : subst.

Definition __array_write := 
  TAbs (
    TAbs (
      TAbs (
        TLetPair (TVar 2) (
          TLetPair (TVar 3) (
            TLetPair (TApp (TVar 1) (TVar 3)) (
              TPair (TApp (TApp (TVar 2) (TVar 5)) (TPair (TVar 6) (TVar 0))) (
                TVar 4
              )
            )
          )
        )
      )
    )
  )
.

Lemma closed___array_write:
  closed_tterm __array_write.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed___array_write.

Lemma lift___array_write:
  forall k,
  lift_tterm k __array_write = __array_write.
Proof.
  auto.
Qed.

Hint Rewrite lift___array_write : lift.

Lemma subst___array_write:
  forall u k,
  subst_tterm u k __array_write = __array_write.
Proof.
  auto.
Qed.

Hint Rewrite subst___array_write : subst.

Definition array_end_index := 
  TAbs (
    TLetPair (TVar 0) (
      TPair (TAbs (TApp (TApp (__array_read) (TVar 0)) (TVar 1))) (
        TAbs (TApp (TApp (__array_write) (TVar 0)) (TVar 1))
      )
    )
  )
.

Lemma closed_array_end_index:
  closed_tterm array_end_index.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_array_end_index.

Lemma lift_array_end_index:
  forall k,
  lift_tterm k array_end_index = array_end_index.
Proof.
  auto.
Qed.

Hint Rewrite lift_array_end_index : lift.

Lemma subst_array_end_index:
  forall u k,
  subst_tterm u k array_end_index = array_end_index.
Proof.
  auto.
Qed.

Hint Rewrite subst_array_end_index : subst.

Definition store_end_index := TAbs (TApp (array_end_index) (TVar 0)).

Lemma closed_store_end_index:
  closed_tterm store_end_index.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_store_end_index.

Lemma lift_store_end_index:
  forall k,
  lift_tterm k store_end_index = store_end_index.
Proof.
  auto.
Qed.

Hint Rewrite lift_store_end_index : lift.

Lemma subst_store_end_index:
  forall u k,
  subst_tterm u k store_end_index = store_end_index.
Proof.
  auto.
Qed.

Hint Rewrite subst_store_end_index : subst.

Definition __zero_get := TAbs (TVar 0).

Lemma closed___zero_get:
  closed_tterm __zero_get.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed___zero_get.

Lemma lift___zero_get:
  forall k,
  lift_tterm k __zero_get = __zero_get.
Proof.
  auto.
Qed.

Hint Rewrite lift___zero_get : lift.

Lemma subst___zero_get:
  forall u k,
  subst_tterm u k __zero_get = __zero_get.
Proof.
  auto.
Qed.

Hint Rewrite subst___zero_get : subst.

Definition __zero_set := TAbs (TAbs (TVar 0)).

Lemma closed___zero_set:
  closed_tterm __zero_set.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed___zero_set.

Lemma lift___zero_set:
  forall k,
  lift_tterm k __zero_set = __zero_set.
Proof.
  auto.
Qed.

Hint Rewrite lift___zero_set : lift.

Lemma subst___zero_set:
  forall u k,
  subst_tterm u k __zero_set = __zero_set.
Proof.
  auto.
Qed.

Hint Rewrite subst___zero_set : subst.

Definition __zero := TPair (__zero_get) (__zero_set).

Lemma closed___zero:
  closed_tterm __zero.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed___zero.

Lemma lift___zero:
  forall k,
  lift_tterm k __zero = __zero.
Proof.
  auto.
Qed.

Hint Rewrite lift___zero : lift.

Lemma subst___zero:
  forall u k,
  subst_tterm u k __zero = __zero.
Proof.
  auto.
Qed.

Hint Rewrite subst___zero : subst.

Definition array_empty := TPair (TUnit) (__zero).

Lemma closed_array_empty:
  closed_tterm array_empty.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_array_empty.

Lemma lift_array_empty:
  forall k,
  lift_tterm k array_empty = array_empty.
Proof.
  auto.
Qed.

Hint Rewrite lift_array_empty : lift.

Lemma subst_array_empty:
  forall u k,
  subst_tterm u k array_empty = array_empty.
Proof.
  auto.
Qed.

Hint Rewrite subst_array_empty : subst.

Definition store_empty := array_empty.

Lemma closed_store_empty:
  closed_tterm store_empty.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_store_empty.

Lemma lift_store_empty:
  forall k,
  lift_tterm k store_empty = store_empty.
Proof.
  auto.
Qed.

Hint Rewrite lift_store_empty : lift.

Lemma subst_store_empty:
  forall u k,
  subst_tterm u k store_empty = store_empty.
Proof.
  auto.
Qed.

Hint Rewrite subst_store_empty : subst.

Definition forward := TAbs (TVar 0).

Lemma closed_forward:
  closed_tterm forward.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_forward.

Lemma lift_forward:
  forall k,
  lift_tterm k forward = forward.
Proof.
  auto.
Qed.

Hint Rewrite lift_forward : lift.

Lemma subst_forward:
  forall u k,
  subst_tterm u k forward = forward.
Proof.
  auto.
Qed.

Hint Rewrite subst_forward : subst.

Definition __return := TAbs (TAbs (TPair (TApp (forward) (TVar 1)) (TVar 0))).

Lemma closed___return:
  closed_tterm __return.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed___return.

Lemma lift___return:
  forall k,
  lift_tterm k __return = __return.
Proof.
  auto.
Qed.

Hint Rewrite lift___return : lift.

Lemma subst___return:
  forall u k,
  subst_tterm u k __return = __return.
Proof.
  auto.
Qed.

Hint Rewrite subst___return : subst.

Definition array_read := TAbs (TAbs (TLetPair (TVar 0) (TApp (TVar 1) (TVar 3)))).

Lemma closed_array_read:
  closed_tterm array_read.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_array_read.

Lemma lift_array_read:
  forall k,
  lift_tterm k array_read = array_read.
Proof.
  auto.
Qed.

Hint Rewrite lift_array_read : lift.

Lemma subst_array_read:
  forall u k,
  subst_tterm u k array_read = array_read.
Proof.
  auto.
Qed.

Hint Rewrite subst_array_read : subst.

Definition read := TAbs (TAbs (TPair (TApp (TApp (array_read) (TVar 0)) (TVar 1)) (TVar 0))).

Lemma closed_read:
  closed_tterm read.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_read.

Lemma lift_read:
  forall k,
  lift_tterm k read = read.
Proof.
  auto.
Qed.

Hint Rewrite lift_read : lift.

Lemma subst_read:
  forall u k,
  subst_tterm u k read = read.
Proof.
  auto.
Qed.

Hint Rewrite subst_read : subst.

Definition pair_box := TAbs (TLetPair (TVar 0) (TPair (TVar 1) (TVar 0))).

Lemma closed_pair_box:
  closed_tterm pair_box.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_pair_box.

Lemma lift_pair_box:
  forall k,
  lift_tterm k pair_box = pair_box.
Proof.
  auto.
Qed.

Hint Rewrite lift_pair_box : lift.

Lemma subst_pair_box:
  forall u k,
  subst_tterm u k pair_box = pair_box.
Proof.
  auto.
Qed.

Hint Rewrite subst_pair_box : subst.

Definition index_monotonic := TAbs (TLetPair (TVar 0) (TPair (TVar 1) (TVar 0))).

Lemma closed_index_monotonic:
  closed_tterm index_monotonic.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_index_monotonic.

Lemma lift_index_monotonic:
  forall k,
  lift_tterm k index_monotonic = index_monotonic.
Proof.
  auto.
Qed.

Hint Rewrite lift_index_monotonic : lift.

Lemma subst_index_monotonic:
  forall u k,
  subst_tterm u k index_monotonic = index_monotonic.
Proof.
  auto.
Qed.

Hint Rewrite subst_index_monotonic : subst.

Definition box_ref := TAbs (TApp (index_monotonic) (TVar 0)).

Lemma closed_box_ref:
  closed_tterm box_ref.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_box_ref.

Lemma lift_box_ref:
  forall k,
  lift_tterm k box_ref = box_ref.
Proof.
  auto.
Qed.

Hint Rewrite lift_box_ref : lift.

Lemma subst_box_ref:
  forall u k,
  subst_tterm u k box_ref = box_ref.
Proof.
  auto.
Qed.

Hint Rewrite subst_box_ref : subst.

Definition new := 
  TAbs (
    TAbs (
      TPair (TApp (box_ref) (TApp (store_end_index) (TVar 0))) (
        TApp (TApp (store_extend) (TVar 0)) (TApp (forward) (TVar 1))
      )
    )
  )
.

Lemma closed_new:
  closed_tterm new.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_new.

Lemma lift_new:
  forall k,
  lift_tterm k new = new.
Proof.
  auto.
Qed.

Hint Rewrite lift_new : lift.

Lemma subst_new:
  forall u k,
  subst_tterm u k new = new.
Proof.
  auto.
Qed.

Hint Rewrite subst_new : subst.

Definition box_univ := TAbs (TVar 0).

Lemma closed_box_univ:
  closed_tterm box_univ.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_box_univ.

Lemma lift_box_univ:
  forall k,
  lift_tterm k box_univ = box_univ.
Proof.
  auto.
Qed.

Hint Rewrite lift_box_univ : lift.

Lemma subst_box_univ:
  forall u k,
  subst_tterm u k box_univ = box_univ.
Proof.
  auto.
Qed.

Hint Rewrite subst_box_univ : subst.

Definition box_unit := TUnit.

Lemma closed_box_unit:
  closed_tterm box_unit.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_box_unit.

Lemma lift_box_unit:
  forall k,
  lift_tterm k box_unit = box_unit.
Proof.
  auto.
Qed.

Hint Rewrite lift_box_unit : lift.

Lemma subst_box_unit:
  forall u k,
  subst_tterm u k box_unit = box_unit.
Proof.
  auto.
Qed.

Hint Rewrite subst_box_unit : subst.

Definition box_boxbox := TAbs (TVar 0).

Lemma closed_box_boxbox:
  closed_tterm box_boxbox.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_box_boxbox.

Lemma lift_box_boxbox:
  forall k,
  lift_tterm k box_boxbox = box_boxbox.
Proof.
  auto.
Qed.

Hint Rewrite lift_box_boxbox : lift.

Lemma subst_box_boxbox:
  forall u k,
  subst_tterm u k box_boxbox = box_boxbox.
Proof.
  auto.
Qed.

Hint Rewrite subst_box_boxbox : subst.

Definition backward := TAbs (TLet (TVar 0) (TVar 0)).

Lemma closed_backward:
  closed_tterm backward.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_backward.

Lemma lift_backward:
  forall k,
  lift_tterm k backward = backward.
Proof.
  auto.
Qed.

Hint Rewrite lift_backward : lift.

Lemma subst_backward:
  forall u k,
  subst_tterm u k backward = backward.
Proof.
  auto.
Qed.

Hint Rewrite subst_backward : subst.

Definition bind := 
  TAbs (
    TLetPair (TApp (box_pair) (TVar 0)) (
      TLet (TVar 1) (
        TLet (TVar 1) (
          TAbs (
            TLet (TApp (TVar 2) (TVar 0)) (
              TLet (TVar 0) (
                TLetPair (TVar 0) (
                  TLet (TVar 1) (
                    TLet (TVar 1) (
                      TLet (TApp (TApp (TVar 7) (TVar 1)) (TVar 0)) (
                        TApp (backward) (TVar 0)
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
    )
  )
.

Lemma closed_bind:
  closed_tterm bind.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_bind.

Lemma lift_bind:
  forall k,
  lift_tterm k bind = bind.
Proof.
  auto.
Qed.

Hint Rewrite lift_bind : lift.

Lemma subst_bind:
  forall u k,
  subst_tterm u k bind = bind.
Proof.
  auto.
Qed.

Hint Rewrite subst_bind : subst.

Definition app := TAbs (TVar 0).

Lemma closed_app:
  closed_tterm app.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_app.

Lemma lift_app:
  forall k,
  lift_tterm k app = app.
Proof.
  auto.
Qed.

Hint Rewrite lift_app : lift.

Lemma subst_app:
  forall u k,
  subst_tterm u k app = app.
Proof.
  auto.
Qed.

Hint Rewrite subst_app : subst.

Definition abs := TAbs (TVar 0).

Lemma closed_abs:
  closed_tterm abs.
Proof.
  unfold closed_tterm, closed, well_scoped_lift. auto.
Qed.

Hint Resolve closed_abs.

Lemma lift_abs:
  forall k,
  lift_tterm k abs = abs.
Proof.
  auto.
Qed.

Hint Rewrite lift_abs : lift.

Lemma subst_abs:
  forall u k,
  subst_tterm u k abs = abs.
Proof.
  auto.
Qed.

Hint Rewrite subst_abs : subst.

